### Method

# Gio File monitor_file

#### Declaration

    GFileMonitor*
    g_file_monitor_file (
      GFile* file,
      GFileMonitorFlags flags,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Obtains a file monitor for the given file. If no file notification mechanism exists, then regular polling of the file is used.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

If `flags` contains `G_FILE_MONITOR_WATCH_HARD_LINKS` then the monitor will also attempt to report changes made to the file via another filename (ie, a hard link). Without this flag, you can only rely on changes made through the filename contained in `file` to be reported. Using this flag may result in an increase in resource usage, and may not have any effect depending on the `GFileMonitor` backend and/or filesystem type.

#### Parameters

`flags`

  Type: `GFileMonitorFlags`

  A set of `GFileMonitorFlags`.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFileMonitor`

A `GFileMonitor` for the given `file`, or `NULL` on error. Free the returned object with g_object_unref().

The caller of the method takes ownership of the data, and is responsible for freeing it.